/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: startup.c 843 2011-07-15 03:17:19Z ertl-honda $
 */

/*
 *		ͥνȽλ
 */

#include "kernel_impl.h"
#include "time_event.h"
#include <sil.h>
#include "mp.h"
#include "spin_lock.h"

/*
 *  ȥ졼ޥΥǥե
 */
#ifndef LOG_KER_ENTER
#define LOG_KER_ENTER()
#endif /* LOG_KER_ENTER */

#ifndef LOG_KER_LEAVE
#define LOG_KER_LEAVE()
#endif /* LOG_KER_LEAVE */

#ifndef LOG_EXT_KER_ENTER
#define LOG_EXT_KER_ENTER()
#endif /* LOG_EXT_KER_ENTER */

#ifndef LOG_EXT_KER_LEAVE
#define LOG_EXT_KER_LEAVE(ercd)
#endif /* LOG_EXT_KER_LEAVE */

#ifdef TOPPERS_sta_ker

/*
 *  ͥεư
 */
void
sta_ker(void)
{
	PCB *my_p_pcb;

	/*
	 *  åȰ¸ν
	 */
	target_initialize();

	/*
	 *  ƥ⥸塼ν
	 *
	 *  ।٥ȴ⥸塼¾Υ⥸塼˽
	 *  ɬפ롥
	 */
	initialize_pcb();
	initialize_tmevt();
	initialize_object();

	/*
	 *  롼μ¹
	 *
	 *  ޥץåˤμ¹ԤλƤ顤졼֥ץåϼ
	 *  Ԥ롥
	 */
	barrier_sync(1);

	if (x_sense_mprc()) {
		call_global_inirtn();
	}

	barrier_sync(2);

	call_local_inirtn();

	/*
	 *  ֥ȤνԤΥХꥢƱ
	 */
	barrier_sync(3);

	/*
	 *  ͥưγ
	 */
	my_p_pcb = get_my_p_pcb();
	my_p_pcb->kerflg = true;
	LOG_KER_ENTER();
	start_dispatch();
	assert(0);
}

#endif /* TOPPERS_sta_ker */

/*
 *  ͥνλ
 */
#ifdef TOPPERS_ext_ker

ER
ext_ker(void)
{
	PCB *my_p_pcb;

	SIL_PRE_LOC;

	LOG_EXT_KER_ENTER();

	/*
	 *  ߥå֤˰ܹ
	 */
	SIL_LOC_INT();

	my_p_pcb = get_my_p_pcb();

	/*
	 *  ԥåƤϡԥå
	 */
	force_unlock_spin(my_p_pcb);

	/*
	 *  ͥưνλ
	 */
	LOG_KER_LEAVE();
	my_p_pcb->kerflg = false;

	/*
	 *  ¾Υץåؽλ׵᤹
	 */
	ext_ker_request();

	/*
	 *  ͥνλθƽФ
	 *
	 *  󥿥ƥȤڤ괹ơexit_kernelƤӽФ
	 */
	call_exit_kernel();

	/* 
	 *  ѥηٹкʤ뤳ȤϤʤϤ 
	 */ 
	SIL_UNL_INT();
	LOG_EXT_KER_LEAVE(E_SYS);
	return(E_SYS);
}

/*
 *  ͥνλ
 */
void
exit_kernel(void)
{
	/*
	 *  SILԥåζ
	 */
	TOPPERS_sil_force_unl_spn();

	barrier_sync(4);

	/*
	 *  λ롼μ¹
	 */
	call_local_terrtn();

	barrier_sync(5);

	if (x_sense_mprc()) {
		call_global_terrtn();
	}

	barrier_sync(6);

	/*
	 *  åȰ¸νλ
	 */
	target_exit();
	assert(0);
}

#endif /* TOPPERS_ext_ker */
